////////////////////////////////////////////////////////////////////////////////
// Jazarsoft VCL Pack (JVP)                                                   //
////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// This code may be used and modified by anyone so long as  this header and   //
// copyright  information remains intact.                                     //
//                                                                            //
// The code is provided "AS-IS" and without WARRANTY OF ANY KIND,             //
// expressed, implied or otherwise, including and without limitation, any     //
// warranty of merchantability or fitness for a  particular purpose.         //
//                                                                            //
// In no event shall the author be liable for any special, incidental,        //
// indirect or consequential damages whatsoever (including, without           //
// limitation, damages for loss of profits, business interruption, loss       //
// of information, or any other loss), whether or not advised of the          //
// possibility of damage, and on any theory of liability, arising out of      //
// or in connection with the use or inability to use this software.         //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ShellApi, jsMaxMem, ComCtrls;
  
type
  TfrmMain = class(TForm)
    Background: TImage;
    bDefrag: TButton;
    bAbort: TButton;
    bVisit: TButton;
    bClose: TButton;
    ProgressBar: TProgressBar;
    jsMaxMem: TjsMaxMem;
    Label1: TLabel;
    lFreeRAM: TLabel;
    Timer: TTimer;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure bCloseClick(Sender: TObject);
    procedure bVisitClick(Sender: TObject);
    procedure bDefragClick(Sender: TObject);
    procedure bAbortClick(Sender: TObject);
    procedure jsMaxMemBeforeDefrag(Sender: TObject);
    procedure jsMaxMemAfterDefrag(Sender: TObject);
    procedure jsMaxMemProgress(Sender: TObject; Progress: Integer);
    procedure TimerTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses uThankYou;

{$R *.DFM}

procedure RemoveCaption(AForm :TForm);
var
  FDiff: integer;
begin
  FDiff:=GetSystemMetrics(SM_CYCAPTION);
  SetWindowLong(AForm.Handle,GWL_STYLE,GetWindowLong(AForm.Handle,GWL_Style) and not WS_Caption);
  AForm.Height:=AForm.Height-FDiff;
end;

procedure TfrmMain.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  Perform(WM_SYSCOMMAND,$f012,0);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  RemoveCaption(Self);
end;

procedure TfrmMain.bCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.bVisitClick(Sender: TObject);
begin
  ShellExecute(Handle,'open','http://www.jazarsoft.com','','',SW_SHOWNORMAL);
end;

procedure TfrmMain.bDefragClick(Sender: TObject);
begin
  jsMaxMem.DefragAll;
end;

procedure TfrmMain.bAbortClick(Sender: TObject);
begin
  jsMaxMem.Abort;
end;

procedure TfrmMain.jsMaxMemBeforeDefrag(Sender: TObject);
begin
  bDefrag.Enabled:=False;
  bAbort.Enabled:=True;
  Timer.Enabled:=False;
  ProgressBar.Visible:=True;
end;

procedure TfrmMain.jsMaxMemAfterDefrag(Sender: TObject);
begin
  bDefrag.Enabled:=True;
  bAbort.Enabled:=False;
  Timer.Enabled:=True;
  ProgressBar.Visible:=False;
end;

procedure TfrmMain.jsMaxMemProgress(Sender: TObject;
  Progress: Integer);
begin
 ProgressBar.Position:=Progress;
end;

procedure TfrmMain.TimerTimer(Sender: TObject);
begin
  lFreeRAM.Caption:=Format('%d KB',[jsMaxMem.FreeMemory div 1024]);
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Hide;
  frmThankYou.ShowModal;
end;

end.
